'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _asyncGenerator2 = require('babel-runtime/helpers/asyncGenerator');

var _asyncGenerator3 = _interopRequireDefault(_asyncGenerator2);

exports.default = initCreateLifecycle;

var _appManagerError = require('./utils/app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var loadingStatusDetails = {
  level: _constants.levels.INFO,
  status: _constants.statuses.LOADING
};

var defaultStatusDetails = {
  level: _constants.levels.INFO,
  status: _constants.statuses.DEFAULT
};

function getErrorStatusDetails(amError) {
  return {
    level: amError.level || _constants.levels.ERROR,
    status: _constants.statuses.ERROR,
    message: amError.message
  };
}

function initCreateLifecycle(slots, getFragmentScript, getSlotElement, context, onRecoverableError) {
  return function () {
    var _ref = _asyncGenerator3.default.wrap( /*#__PURE__*/_regenerator2.default.mark(function _callee6(container, slotName, fragmentName) {
      var getScript = function () {
        var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
          var getErrorMarkup, errorSlotElement;
          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.prev = 0;
                  _context.next = 3;
                  return getFragmentScript(fragmentName);

                case 3:
                  return _context.abrupt('return', _context.sent);

                case 6:
                  _context.prev = 6;
                  _context.t0 = _context['catch'](0);
                  getErrorMarkup = slot.getErrorMarkup;

                  if (!(typeof getErrorMarkup === 'function')) {
                    _context.next = 23;
                    break;
                  }

                  _context.prev = 10;
                  _context.next = 13;
                  return getSlotElement(container, slotName, fragmentName);

                case 13:
                  errorSlotElement = _context.sent;

                  if (!errorSlotElement) {
                    _context.next = 18;
                    break;
                  }

                  _context.next = 17;
                  return getErrorMarkup(context.state);

                case 17:
                  errorSlotElement.innerHTML = _context.sent;

                case 18:
                  _context.next = 23;
                  break;

                case 20:
                  _context.prev = 20;
                  _context.t1 = _context['catch'](10);

                  onRecoverableError(_context.t1);

                case 23:

                  onRecoverableError(_context.t0);

                  throw _context.t0;

                case 25:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, this, [[0, 6], [10, 20]]);
        }));

        return function getScript() {
          return _ref2.apply(this, arguments);
        };
      }();

      var updateStatus = function () {
        var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(statusDetails) {
          return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.prev = 0;
                  _context2.next = 3;
                  return script.onUpdateStatus(statusDetails, context.state);

                case 3:
                  _context2.next = 8;
                  break;

                case 5:
                  _context2.prev = 5;
                  _context2.t0 = _context2['catch'](0);

                  onRecoverableError(_context2.t0);

                case 8:
                case 'end':
                  return _context2.stop();
              }
            }
          }, _callee2, this, [[0, 5]]);
        }));

        return function updateStatus(_x4) {
          return _ref3.apply(this, arguments);
        };
      }();

      var getLifecycleElement = function () {
        var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
          return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  _context3.prev = 0;
                  _context3.next = 3;
                  return getSlotElement(container, slotName, fragmentName);

                case 3:
                  return _context3.abrupt('return', _context3.sent);

                case 6:
                  _context3.prev = 6;
                  _context3.t0 = _context3['catch'](0);
                  _context3.next = 10;
                  return updateStatus(getErrorStatusDetails(_context3.t0));

                case 10:
                  throw _context3.t0;

                case 11:
                case 'end':
                  return _context3.stop();
              }
            }
          }, _callee3, this, [[0, 6]]);
        }));

        return function getLifecycleElement() {
          return _ref4.apply(this, arguments);
        };
      }();

      var unmount = function () {
        var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
          var unmountSlotElement, amError;
          return _regenerator2.default.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  _context4.next = 2;
                  return getLifecycleElement();

                case 2:
                  unmountSlotElement = _context4.sent;

                  if (!unmountSlotElement) {
                    _context4.next = 15;
                    break;
                  }

                  _context4.prev = 4;
                  _context4.next = 7;
                  return script.unmount(unmountSlotElement, context.state);

                case 7:
                  _context4.next = 15;
                  break;

                case 9:
                  _context4.prev = 9;
                  _context4.t0 = _context4['catch'](4);
                  amError = new _appManagerError2.default(_context4.t0, (0, _extends3.default)({}, errData, {
                    level: _constants.levels.ERROR,
                    code: 'unmount',
                    recoverable: true
                  }));
                  _context4.next = 14;
                  return updateStatus(getErrorStatusDetails(amError));

                case 14:
                  throw amError;

                case 15:
                case 'end':
                  return _context4.stop();
              }
            }
          }, _callee4, this, [[4, 9]]);
        }));

        return function unmount() {
          return _ref5.apply(this, arguments);
        };
      }();

      var handleError = function () {
        var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(err) {
          var getErrorMarkup, errorSlotElement;
          return _regenerator2.default.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  _context5.prev = 0;
                  _context5.next = 3;
                  return updateStatus(getErrorStatusDetails(err));

                case 3:
                  _context5.next = 5;
                  return unmount();

                case 5:
                  _context5.next = 10;
                  break;

                case 7:
                  _context5.prev = 7;
                  _context5.t0 = _context5['catch'](0);

                  onRecoverableError(_context5.t0);

                case 10:
                  getErrorMarkup = slot.getErrorMarkup;

                  if (!(typeof getErrorMarkup === 'function')) {
                    _context5.next = 25;
                    break;
                  }

                  _context5.prev = 12;
                  _context5.next = 15;
                  return getLifecycleElement();

                case 15:
                  errorSlotElement = _context5.sent;

                  if (!errorSlotElement) {
                    _context5.next = 20;
                    break;
                  }

                  _context5.next = 19;
                  return getErrorMarkup(context.state);

                case 19:
                  errorSlotElement.innerHTML = _context5.sent;

                case 20:
                  _context5.next = 25;
                  break;

                case 22:
                  _context5.prev = 22;
                  _context5.t1 = _context5['catch'](12);

                  onRecoverableError(_context5.t1);

                case 25:
                case 'end':
                  return _context5.stop();
              }
            }
          }, _callee5, this, [[0, 7], [12, 22]]);
        }));

        return function handleError(_x5) {
          return _ref6.apply(this, arguments);
        };
      }();

      var errData, slot, script, mountSlotElement, amError, stop, _amError, getLoadingMarkup, errorSlotElement;

      return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              errData = {
                source: 'lifecycle',
                fragment: fragmentName,
                slot: slotName
              };
              slot = slots[slotName];
              _context6.next = 4;
              return _asyncGenerator3.default.await(getScript());

            case 4:
              script = _context6.sent;

              if (script) {
                _context6.next = 9;
                break;
              }

              if (!(context.state.eventTitle === _constants.eventTitles.INITIALISE)) {
                _context6.next = 8;
                break;
              }

              return _context6.abrupt('return');

            case 8:
              throw new _appManagerError2.default('Tried to navigate to fragment without a script.', (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'get_script',
                recoverable: true
              }));

            case 9:
              _context6.next = 11;
              return _asyncGenerator3.default.await(updateStatus(loadingStatusDetails));

            case 11:
              _context6.next = 13;
              return _asyncGenerator3.default.await(getLifecycleElement());

            case 13:
              mountSlotElement = _context6.sent;

              if (!mountSlotElement) {
                _context6.next = 31;
                break;
              }

              _context6.prev = 15;

              if (!(context.state.eventTitle === _constants.eventTitles.INITIALISE)) {
                _context6.next = 21;
                break;
              }

              _context6.next = 19;
              return _asyncGenerator3.default.await(script.hydrate(mountSlotElement, context.state));

            case 19:
              _context6.next = 23;
              break;

            case 21:
              _context6.next = 23;
              return _asyncGenerator3.default.await(script.render(mountSlotElement, context.state));

            case 23:
              _context6.next = 31;
              break;

            case 25:
              _context6.prev = 25;
              _context6.t0 = _context6['catch'](15);
              amError = new _appManagerError2.default(_context6.t0, (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'mount',
                recoverable: true
              }));
              _context6.next = 30;
              return _asyncGenerator3.default.await(handleError(_context6.t0));

            case 30:
              throw amError;

            case 31:
              stop = false;

            case 32:
              if (stop) {
                _context6.next = 71;
                break;
              }

            case 33:
              if (!true) {
                _context6.next = 47;
                break;
              }

              _context6.prev = 34;
              _context6.next = 37;
              return;

            case 37:
              stop = _context6.sent;
              return _context6.abrupt('break', 47);

            case 41:
              _context6.prev = 41;
              _context6.t1 = _context6['catch'](34);
              _context6.next = 45;
              return _asyncGenerator3.default.await(updateStatus(getErrorStatusDetails(_context6.t1)));

            case 45:
              _context6.next = 33;
              break;

            case 47:
              _context6.next = 49;
              return _asyncGenerator3.default.await(updateStatus(defaultStatusDetails));

            case 49:
              _context6.next = 51;
              return;

            case 51:
              stop = _context6.sent;
              _context6.next = 54;
              return _asyncGenerator3.default.await(updateStatus(loadingStatusDetails));

            case 54:
              _context6.next = 56;
              return;

            case 56:
              stop = _context6.sent;

              if (stop) {
                _context6.next = 69;
                break;
              }

              _context6.prev = 58;
              _context6.next = 61;
              return _asyncGenerator3.default.await(script.onStateChange(container, context.state));

            case 61:
              _context6.next = 69;
              break;

            case 63:
              _context6.prev = 63;
              _context6.t2 = _context6['catch'](58);
              _amError = new _appManagerError2.default(_context6.t2, (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'on_state_change',
                recoverable: true
              }));
              _context6.next = 68;
              return _asyncGenerator3.default.await(handleError(_context6.t2));

            case 68:
              throw _amError;

            case 69:
              _context6.next = 32;
              break;

            case 71:
              _context6.next = 73;
              return _asyncGenerator3.default.await(unmount());

            case 73:
              getLoadingMarkup = slot.getLoadingMarkup;

              if (!(typeof getLoadingMarkup === 'function')) {
                _context6.next = 88;
                break;
              }

              _context6.prev = 75;
              _context6.next = 78;
              return _asyncGenerator3.default.await(getLifecycleElement());

            case 78:
              errorSlotElement = _context6.sent;

              if (!errorSlotElement) {
                _context6.next = 83;
                break;
              }

              _context6.next = 82;
              return _asyncGenerator3.default.await(getLoadingMarkup(context.state));

            case 82:
              errorSlotElement.innerHTML = _context6.sent;

            case 83:
              _context6.next = 88;
              break;

            case 85:
              _context6.prev = 85;
              _context6.t3 = _context6['catch'](75);

              onRecoverableError(_context6.t3);

            case 88:
              _context6.next = 90;
              return _asyncGenerator3.default.await(updateStatus(defaultStatusDetails));

            case 90:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, this, [[15, 25], [34, 41], [58, 63], [75, 85]]);
    }));

    function createLifecycle(_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    }

    return createLifecycle;
  }();
}