'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

exports.default = initGetFragmentScript;

var _appManagerError = require('./utils/app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _config = require('./utils/config');

var _constants = require('./constants');

var _wrapScript = require('./utils/wrap-script');

var _wrapScript2 = _interopRequireDefault(_wrapScript);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function initGetFragmentScript(fragments, importTimeout, context) {
  var cachedScripts = new _map2.default();

  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(fragmentName) {
      var cachedScript, errData, loadScript, wrappedScript, script;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              cachedScript = cachedScripts.get(fragmentName);

              if (!cachedScript) {
                _context.next = 3;
                break;
              }

              return _context.abrupt('return', cachedScript);

            case 3:
              errData = {
                source: 'load_script',
                fragment: fragmentName,
                slot: null
              };
              loadScript = fragments[fragmentName].loadScript;
              wrappedScript = null;

              if (!(typeof loadScript === 'function')) {
                _context.next = 20;
                break;
              }

              script = void 0;
              _context.prev = 8;
              _context.next = 11;
              return _promise2.default.race([loadScript(context.state), (0, _config.delay)(importTimeout)]);

            case 11:
              script = _context.sent;
              _context.next = 17;
              break;

            case 14:
              _context.prev = 14;
              _context.t0 = _context['catch'](8);
              throw new _appManagerError2.default(_context.t0, (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'load_script',
                recoverable: true
              }));

            case 17:
              if (script) {
                _context.next = 19;
                break;
              }

              throw new _appManagerError2.default('loadScript timed out for fragment ' + fragmentName + '.', (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'time_out',
                recoverable: true
              }));

            case 19:

              wrappedScript = (0, _wrapScript2.default)(script);

            case 20:

              cachedScripts.set(fragmentName, wrappedScript);
              return _context.abrupt('return', wrappedScript);

            case 22:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[8, 14]]);
    }));

    function getFragmentScript(_x) {
      return _ref.apply(this, arguments);
    }

    return getFragmentScript;
  }();
}