'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = initUpdateState;

var _appManagerError = require('./utils/app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var errData = {
  source: 'update_state',
  fragment: null,
  slot: null
};

function initUpdateState(routes, getRouteName, getAdditionalState) {
  if (typeof getRouteName !== 'function') {
    throw new _appManagerError2.default('You must provide a way to derive the route name from the current resource.', (0, _extends3.default)({}, errData, {
      level: _constants.levels.ERROR,
      code: 'invalid_options',
      recoverable: false
    }));
  }

  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(parentState, currentRoute) {
      var routeName, additionalState, state, _state, rootState, stateWithoutRoot, _state2, serverState, stateWithoutServer;

      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              routeName = null;
              _context.prev = 1;
              _context.next = 4;
              return getRouteName(parentState);

            case 4:
              routeName = _context.sent;
              _context.next = 10;
              break;

            case 7:
              _context.prev = 7;
              _context.t0 = _context['catch'](1);
              throw new _appManagerError2.default(_context.t0, (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'get_route_name_from_location',
                recoverable: false
              }));

            case 10:
              additionalState = {};

              if (!(typeof getAdditionalState === 'function')) {
                _context.next = 21;
                break;
              }

              _context.prev = 12;
              _context.next = 15;
              return getAdditionalState(routeName, parentState);

            case 15:
              additionalState = _context.sent;
              _context.next = 21;
              break;

            case 18:
              _context.prev = 18;
              _context.t1 = _context['catch'](12);
              throw new _appManagerError2.default(_context.t1, (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'get_additional_state',
                recoverable: false
              }));

            case 21:
              state = parentState;


              if (state.rootState) {
                _state = state, rootState = _state.rootState, stateWithoutRoot = (0, _objectWithoutProperties3.default)(_state, ['rootState']);

                state = stateWithoutRoot;
              }

              if (state.serverState) {
                _state2 = state, serverState = _state2.serverState, stateWithoutServer = (0, _objectWithoutProperties3.default)(_state2, ['serverState']);

                state = stateWithoutServer;
              }

              return _context.abrupt('return', (0, _extends3.default)({}, additionalState, state, {
                prevRoute: currentRoute || null,
                route: typeof routeName === 'string' && routeName in routes ? routes[routeName] : null
              }));

            case 25:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[1, 7], [12, 18]]);
    }));

    function updateState(_x, _x2) {
      return _ref.apply(this, arguments);
    }

    return updateState;
  }();
}