'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

exports.default = initUpdatePage;

var _appManagerError = require('./utils/app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function initUpdatePage(reconcile, createLifecycle, onRecoverableError) {
  var handleLifecycleError = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(slotName, err) {
      var lifecyclesArray;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              mountedLifecycles.delete(slotName);

              lifecyclesArray = (0, _from2.default)(mountedLifecycles.values());
              _context.next = 4;
              return _promise2.default.all(lifecyclesArray.map(function (lifecycle) {
                return lifecycle.throw(err);
              }));

            case 4:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function handleLifecycleError(_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();

  var updateAllSlots = function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
      var lifecyclesArray;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              lifecyclesArray = (0, _from2.default)(mountedLifecycles.values());
              _context2.next = 3;
              return _promise2.default.all(lifecyclesArray.map(function (lifecycle) {
                return lifecycle.next(false);
              }));

            case 3:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    return function updateAllSlots() {
      return _ref2.apply(this, arguments);
    };
  }();

  var mountedLifecycles = new _map2.default();

  return function () {
    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(container, state) {
      var _this = this;

      var newRouteName, prevRouteName, _reconcile, unmount, mount, update, slotsToUpdate, slotsToUnmount, slotsToMount, updatePromises, unmountPromises, mountPromises;

      return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              newRouteName = state.route ? state.route.name : null;
              prevRouteName = state.prevRoute ? state.prevRoute.name : null;
              _reconcile = reconcile(newRouteName, prevRouteName), unmount = _reconcile.unmount, mount = _reconcile.mount, update = _reconcile.update;
              slotsToUpdate = (0, _keys2.default)(update);
              slotsToUnmount = (0, _keys2.default)(unmount);
              slotsToMount = (0, _keys2.default)(mount);

              updatePromises = function updatePromises() {
                return slotsToUpdate.map(function () {
                  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(slotName) {
                    var lifecycle;
                    return _regenerator2.default.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            _context3.prev = 0;
                            lifecycle = mountedLifecycles.get(slotName);

                            if (!lifecycle) {
                              _context3.next = 5;
                              break;
                            }

                            _context3.next = 5;
                            return lifecycle.next(false);

                          case 5:
                            _context3.next = 12;
                            break;

                          case 7:
                            _context3.prev = 7;
                            _context3.t0 = _context3['catch'](0);
                            _context3.next = 11;
                            return handleLifecycleError(slotName, _context3.t0);

                          case 11:

                            onRecoverableError(_context3.t0);

                          case 12:
                          case 'end':
                            return _context3.stop();
                        }
                      }
                    }, _callee3, _this, [[0, 7]]);
                  }));

                  return function (_x5) {
                    return _ref4.apply(this, arguments);
                  };
                }());
              };

              unmountPromises = function unmountPromises() {
                return slotsToUnmount.map(function () {
                  var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(slotName) {
                    var lifecycle;
                    return _regenerator2.default.wrap(function _callee4$(_context4) {
                      while (1) {
                        switch (_context4.prev = _context4.next) {
                          case 0:
                            _context4.prev = 0;
                            lifecycle = mountedLifecycles.get(slotName);

                            if (!lifecycle) {
                              _context4.next = 6;
                              break;
                            }

                            _context4.next = 5;
                            return lifecycle.next(true);

                          case 5:
                            mountedLifecycles.delete(slotName);

                          case 6:
                            _context4.next = 13;
                            break;

                          case 8:
                            _context4.prev = 8;
                            _context4.t0 = _context4['catch'](0);
                            _context4.next = 12;
                            return handleLifecycleError(slotName, _context4.t0);

                          case 12:

                            onRecoverableError(_context4.t0);

                          case 13:
                          case 'end':
                            return _context4.stop();
                        }
                      }
                    }, _callee4, _this, [[0, 8]]);
                  }));

                  return function (_x6) {
                    return _ref5.apply(this, arguments);
                  };
                }());
              };

              mountPromises = function mountPromises() {
                return slotsToMount.map(function () {
                  var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(slotName) {
                    var fragmentName, lifecycle;
                    return _regenerator2.default.wrap(function _callee5$(_context5) {
                      while (1) {
                        switch (_context5.prev = _context5.next) {
                          case 0:
                            fragmentName = mount[slotName];

                            if (!mountedLifecycles.has(slotName)) {
                              _context5.next = 3;
                              break;
                            }

                            throw new _appManagerError2.default('Overwriting an existing fragment.', {
                              source: 'update_page',
                              fragment: fragmentName,
                              slot: slotName,
                              level: _constants.levels.ERROR,
                              code: 'overwrite_existing',
                              recoverable: true
                            });

                          case 3:
                            _context5.prev = 3;
                            _context5.next = 6;
                            return createLifecycle(container, slotName, fragmentName);

                          case 6:
                            lifecycle = _context5.sent;
                            _context5.next = 9;
                            return lifecycle.next(false);

                          case 9:
                            mountedLifecycles.set(slotName, lifecycle);
                            _context5.next = 17;
                            break;

                          case 12:
                            _context5.prev = 12;
                            _context5.t0 = _context5['catch'](3);
                            _context5.next = 16;
                            return handleLifecycleError(slotName, _context5.t0);

                          case 16:

                            onRecoverableError(_context5.t0);

                          case 17:
                          case 'end':
                            return _context5.stop();
                        }
                      }
                    }, _callee5, _this, [[3, 12]]);
                  }));

                  return function (_x7) {
                    return _ref6.apply(this, arguments);
                  };
                }());
              };

              _context6.next = 11;
              return updateAllSlots();

            case 11:
              _context6.next = 13;
              return _promise2.default.all(updatePromises());

            case 13:
              _context6.next = 15;
              return _promise2.default.all(unmountPromises());

            case 15:
              _context6.next = 17;
              return _promise2.default.all(mountPromises());

            case 17:
              _context6.next = 19;
              return updateAllSlots();

            case 19:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, this);
    }));

    function updatePage(_x3, _x4) {
      return _ref3.apply(this, arguments);
    }

    return updatePage;
  }();
}