'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

exports.getV5State = getV5State;
exports.default = wrapScript;

var _appManagerError = require('./app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getV5State(state) {
  var route = state.route,
      prevRoute = state.prevRoute;


  var app = null;

  if (route) {
    app = {};

    if (typeof route.fragment === 'string') {
      (0, _assign2.default)(app, { fragment: route.fragment });
    }

    if (Array.isArray(route.fragments)) {
      (0, _assign2.default)(app, { fragments: route.fragments });
    }

    if (typeof route.path === 'string') {
      (0, _assign2.default)(app, { appPath: route.path });
    }

    if (Array.isArray(route.paths)) {
      (0, _assign2.default)(app, { appPaths: route.paths });
    }
  }

  var prevApp = null;

  if (prevRoute) {
    prevApp = {};

    if (typeof prevRoute.fragment === 'string') {
      (0, _assign2.default)(prevApp, { fragment: prevRoute.fragment });
    }

    if (Array.isArray(prevRoute.fragments)) {
      (0, _assign2.default)(prevApp, { fragments: prevRoute.fragments });
    }

    if (typeof prevRoute.path === 'string') {
      (0, _assign2.default)(prevApp, { appPath: prevRoute.path });
    }

    if (Array.isArray(prevRoute.paths)) {
      (0, _assign2.default)(prevApp, { appPaths: prevRoute.paths });
    }
  }

  return (0, _extends3.default)({}, state, { app: app, prevApp: prevApp });
}

var errData = {
  source: 'wrap_script',
  fragment: null,
  slot: null
};

function wrapScript(script) {
  return {
    version: script.version,

    hydrate: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(slotElement, state) {
        var v5State, _v5State;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.t0 = script.version;
                _context.next = _context.t0 === 4 ? 3 : _context.t0 === 5 ? 14 : _context.t0 === 6 ? 25 : 35;
                break;

              case 3:
                if (!state) {
                  _context.next = 13;
                  break;
                }

                v5State = getV5State(state);

                if (!(typeof script.hydrate === 'function')) {
                  _context.next = 10;
                  break;
                }

                _context.next = 8;
                return script.hydrate(slotElement, v5State.app);

              case 8:
                _context.next = 13;
                break;

              case 10:
                if (!(typeof script.mount === 'function')) {
                  _context.next = 13;
                  break;
                }

                _context.next = 13;
                return script.mount(slotElement, 'am-replaceState', v5State.app);

              case 13:
                return _context.abrupt('break', 36);

              case 14:
                if (!state) {
                  _context.next = 24;
                  break;
                }

                _v5State = getV5State(state);

                if (!(typeof script.hydrate === 'function')) {
                  _context.next = 21;
                  break;
                }

                _context.next = 19;
                return script.hydrate(slotElement, _v5State);

              case 19:
                _context.next = 24;
                break;

              case 21:
                if (!(typeof script.render === 'function')) {
                  _context.next = 24;
                  break;
                }

                _context.next = 24;
                return script.render(slotElement, _v5State);

              case 24:
                return _context.abrupt('break', 36);

              case 25:
                if (!state) {
                  _context.next = 34;
                  break;
                }

                if (!(typeof script.hydrate === 'function')) {
                  _context.next = 31;
                  break;
                }

                _context.next = 29;
                return script.hydrate(slotElement, state);

              case 29:
                _context.next = 34;
                break;

              case 31:
                if (!(typeof script.render === 'function')) {
                  _context.next = 34;
                  break;
                }

                _context.next = 34;
                return script.render(slotElement, state);

              case 34:
                return _context.abrupt('break', 36);

              case 35:
                throw new _appManagerError2.default('Script has invalid version.', (0, _extends3.default)({}, errData, {
                  level: _constants.levels.ERROR,
                  code: 'invalid_version',
                  recoverable: false
                }));

              case 36:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function hydrate(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return hydrate;
    }(),
    render: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(slotElement, state) {
        var v5State, _v5State2;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.t0 = script.version;
                _context2.next = _context2.t0 === 4 ? 3 : _context2.t0 === 5 ? 9 : _context2.t0 === 6 ? 15 : 19;
                break;

              case 3:
                if (!state) {
                  _context2.next = 8;
                  break;
                }

                v5State = getV5State(state);

                if (!(typeof script.mount === 'function')) {
                  _context2.next = 8;
                  break;
                }

                _context2.next = 8;
                return script.mount(slotElement, state.eventTitle, v5State.app);

              case 8:
                return _context2.abrupt('break', 20);

              case 9:
                if (!state) {
                  _context2.next = 14;
                  break;
                }

                _v5State2 = getV5State(state);

                if (!(typeof script.render === 'function')) {
                  _context2.next = 14;
                  break;
                }

                _context2.next = 14;
                return script.render(slotElement, _v5State2);

              case 14:
                return _context2.abrupt('break', 20);

              case 15:
                if (!(state && typeof script.render === 'function')) {
                  _context2.next = 18;
                  break;
                }

                _context2.next = 18;
                return script.render(slotElement, state);

              case 18:
                return _context2.abrupt('break', 20);

              case 19:
                throw new _appManagerError2.default('Script has invalid version.', (0, _extends3.default)({}, errData, {
                  level: _constants.levels.ERROR,
                  code: 'invalid_version',
                  recoverable: false
                }));

              case 20:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function render(_x3, _x4) {
        return _ref2.apply(this, arguments);
      }

      return render;
    }(),
    onStateChange: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(slotElement, state) {
        var v5State, _v5State3;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.t0 = script.version;
                _context3.next = _context3.t0 === 4 ? 3 : _context3.t0 === 5 ? 9 : _context3.t0 === 6 ? 15 : 19;
                break;

              case 3:
                if (!state) {
                  _context3.next = 8;
                  break;
                }

                v5State = getV5State(state);

                if (!(typeof script.onStateChange === 'function')) {
                  _context3.next = 8;
                  break;
                }

                _context3.next = 8;
                return script.onStateChange(state.eventTitle, v5State.app);

              case 8:
                return _context3.abrupt('break', 20);

              case 9:
                if (!state) {
                  _context3.next = 14;
                  break;
                }

                _v5State3 = getV5State(state);

                if (!(typeof script.onStateChange === 'function')) {
                  _context3.next = 14;
                  break;
                }

                _context3.next = 14;
                return script.onStateChange(_v5State3);

              case 14:
                return _context3.abrupt('break', 20);

              case 15:
                if (!(state && typeof script.onStateChange === 'function')) {
                  _context3.next = 18;
                  break;
                }

                _context3.next = 18;
                return script.onStateChange(slotElement, state);

              case 18:
                return _context3.abrupt('break', 20);

              case 19:
                throw new _appManagerError2.default('Script has invalid version.', (0, _extends3.default)({}, errData, {
                  level: _constants.levels.ERROR,
                  code: 'invalid_version',
                  recoverable: false
                }));

              case 20:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function onStateChange(_x5, _x6) {
        return _ref3.apply(this, arguments);
      }

      return onStateChange;
    }(),
    unmount: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(slotElement, state) {
        var v5State, _v5State4;

        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.t0 = script.version;
                _context4.next = _context4.t0 === 4 ? 3 : _context4.t0 === 5 ? 9 : _context4.t0 === 6 ? 15 : 19;
                break;

              case 3:
                if (!state) {
                  _context4.next = 8;
                  break;
                }

                v5State = getV5State(state);

                if (!(typeof script.unmount === 'function')) {
                  _context4.next = 8;
                  break;
                }

                _context4.next = 8;
                return script.unmount(slotElement, state.eventTitle, v5State.prevApp);

              case 8:
                return _context4.abrupt('break', 20);

              case 9:
                if (!state) {
                  _context4.next = 14;
                  break;
                }

                _v5State4 = getV5State(state);

                if (!(typeof script.unmount === 'function')) {
                  _context4.next = 14;
                  break;
                }

                _context4.next = 14;
                return script.unmount(slotElement, _v5State4);

              case 14:
                return _context4.abrupt('break', 20);

              case 15:
                if (!(state && typeof script.unmount === 'function')) {
                  _context4.next = 18;
                  break;
                }

                _context4.next = 18;
                return script.unmount(slotElement, state);

              case 18:
                return _context4.abrupt('break', 20);

              case 19:
                throw new _appManagerError2.default('Script has invalid version.', (0, _extends3.default)({}, errData, {
                  level: _constants.levels.ERROR,
                  code: 'invalid_version',
                  recoverable: false
                }));

              case 20:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function unmount(_x7, _x8) {
        return _ref4.apply(this, arguments);
      }

      return unmount;
    }(),
    onUpdateStatus: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(statusDetails, state) {
        var v5State, _v5State5;

        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.t0 = script.version;
                _context5.next = _context5.t0 === 4 ? 3 : _context5.t0 === 5 ? 9 : _context5.t0 === 6 ? 15 : 19;
                break;

              case 3:
                if (!state) {
                  _context5.next = 8;
                  break;
                }

                v5State = getV5State(state);

                if (!(typeof script.onUpdateStatus === 'function')) {
                  _context5.next = 8;
                  break;
                }

                _context5.next = 8;
                return script.onUpdateStatus(statusDetails.status, v5State.app);

              case 8:
                return _context5.abrupt('break', 20);

              case 9:
                if (!state) {
                  _context5.next = 14;
                  break;
                }

                _v5State5 = getV5State(state);

                if (!(typeof script.onUpdateStatus === 'function')) {
                  _context5.next = 14;
                  break;
                }

                _context5.next = 14;
                return script.onUpdateStatus(statusDetails, _v5State5);

              case 14:
                return _context5.abrupt('break', 20);

              case 15:
                if (!(state && typeof script.onUpdateStatus === 'function')) {
                  _context5.next = 18;
                  break;
                }

                _context5.next = 18;
                return script.onUpdateStatus(statusDetails, state);

              case 18:
                return _context5.abrupt('break', 20);

              case 19:
                throw new _appManagerError2.default('Script has invalid version.', (0, _extends3.default)({}, errData, {
                  level: _constants.levels.ERROR,
                  code: 'invalid_version',
                  recoverable: false
                }));

              case 20:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function onUpdateStatus(_x9, _x10) {
        return _ref5.apply(this, arguments);
      }

      return onUpdateStatus;
    }()
  };
}